use v6;
#  -- DO NOT EDIT --
# generated by: etc/generator.p6 

unit module LibXML::Native::Gen::valid;
# The DTD validation:
#    API for the DTD handling and the validity checking 
use LibXML::Native::Defs :$lib, :xmlCharP;

class xmlAttributeTable is repr('CPointer') {
    method Copy( --> xmlAttributeTable) is native(XML2) is symbol('xmlCopyAttributeTable') {*}
    method Free() is native(XML2) is symbol('xmlFreeAttributeTable') {*}
}

class xmlElementTable is repr('CPointer') {
    method Copy( --> xmlElementTable) is native(XML2) is symbol('xmlCopyElementTable') {*}
    method Free() is native(XML2) is symbol('xmlFreeElementTable') {*}
}

class xmlIDTable is repr('CPointer') {
    method Free() is native(XML2) is symbol('xmlFreeIDTable') {*}
}

class xmlNotationTable is repr('CPointer') {
    method Copy( --> xmlNotationTable) is native(XML2) is symbol('xmlCopyNotationTable') {*}
    method Free() is native(XML2) is symbol('xmlFreeNotationTable') {*}
}

class xmlRefTable is repr('CPointer') {
    method Free() is native(XML2) is symbol('xmlFreeRefTable') {*}
}

class xmlValidCtxt is repr('CStruct') {
    has Pointer $.userData; # user specific data block
    has xmlValidityErrorFunc $.error; # the callback in case of errors
    has xmlValidityWarningFunc $.warning; # the callback in case of warning Node analysis stack used when validating within entities
    has xmlNode $.node; # Current parsed Node
    has int32 $.nodeNr; # Depth of the parsing stack
    has int32 $.nodeMax; # Max depth of the parsing stack
    has xmlNodePtr * $.nodeTab; # array of nodes
    has uint32 $.finishDtd; # finished validating the Dtd ?
    has xmlDoc $.doc; # the document
    has int32 $.valid; # temporary validity check result state state used for non-determinist content validation
    has xmlValidState * $.vstate; # current state
    has int32 $.vstateNr; # Depth of the validation stack
    has int32 $.vstateMax; # Max depth of the validation stack
    has xmlValidState * $.vstateTab; # array of validation states
    has xmlAutomata $.am; # the automata
    has xmlAutomataState $.state; # used to build the automata
    has Pointer $.am;
    has Pointer $.state;

    our sub New( --> xmlValidCtxt) is native(XML2) is symbol('xmlNewValidCtxt') {*}

    method AddAttributeDecl(xmlDtd $dtd, xmlCharP $elem, xmlCharP $name, xmlCharP $ns, xmlAttributeType $type, xmlAttributeDefault $def, xmlCharP $defaultValue, xmlEnumeration $tree --> xmlAttribute) is native(XML2) is symbol('xmlAddAttributeDecl') {*}
    method AddElementDecl(xmlDtd $dtd, xmlCharP $name, xmlElementTypeVal $type, xmlElementContent $content --> xmlElement) is native(XML2) is symbol('xmlAddElementDecl') {*}
    method AddID(xmlDoc $doc, xmlCharP $value, xmlAttr $attr --> xmlID) is native(XML2) is symbol('xmlAddID') {*}
    method AddNotationDecl(xmlDtd $dtd, xmlCharP $name, xmlCharP $PublicID, xmlCharP $SystemID --> xmlNotation) is native(XML2) is symbol('xmlAddNotationDecl') {*}
    method AddRef(xmlDoc $doc, xmlCharP $value, xmlAttr $attr --> xmlRef) is native(XML2) is symbol('xmlAddRef') {*}
    method Free() is native(XML2) is symbol('xmlFreeValidCtxt') {*}
    method BuildContentModel(xmlElement $elem --> int32) is native(XML2) is symbol('xmlValidBuildContentModel') {*}
    method NormalizeAttributeValue(xmlDoc $doc, xmlNode $elem, xmlCharP $name, xmlCharP $value --> xmlCharP) is native(XML2) is symbol('xmlValidCtxtNormalizeAttributeValue') {*}
    method ValidateAttributeDecl(xmlDoc $doc, xmlAttribute $attr --> int32) is native(XML2) is symbol('xmlValidateAttributeDecl') {*}
    method ValidateDocument(xmlDoc $doc --> int32) is native(XML2) is symbol('xmlValidateDocument') {*}
    method ValidateDocumentFinal(xmlDoc $doc --> int32) is native(XML2) is symbol('xmlValidateDocumentFinal') {*}
    method ValidateDtd(xmlDoc $doc, xmlDtd $dtd --> int32) is native(XML2) is symbol('xmlValidateDtd') {*}
    method ValidateDtdFinal(xmlDoc $doc --> int32) is native(XML2) is symbol('xmlValidateDtdFinal') {*}
    method ValidateElement(xmlDoc $doc, xmlNode $elem --> int32) is native(XML2) is symbol('xmlValidateElement') {*}
    method ValidateElementDecl(xmlDoc $doc, xmlElement $elem --> int32) is native(XML2) is symbol('xmlValidateElementDecl') {*}
    method ValidateNotationDecl(xmlDoc $doc, xmlNotation $nota --> int32) is native(XML2) is symbol('xmlValidateNotationDecl') {*}
    method ValidateNotationUse(xmlDoc $doc, xmlCharP $notationName --> int32) is native(XML2) is symbol('xmlValidateNotationUse') {*}
    method ValidateOneAttribute(xmlDoc $doc, xmlNode $elem, xmlAttr $attr, xmlCharP $value --> int32) is native(XML2) is symbol('xmlValidateOneAttribute') {*}
    method ValidateOneElement(xmlDoc $doc, xmlNode $elem --> int32) is native(XML2) is symbol('xmlValidateOneElement') {*}
    method ValidateOneNamespace(xmlDoc $doc, xmlNode $elem, xmlCharP $prefix, xmlNs $ns, xmlCharP $value --> int32) is native(XML2) is symbol('xmlValidateOneNamespace') {*}
    method ValidatePopElement(xmlDoc $doc, xmlNode $elem, xmlCharP $qname --> int32) is native(XML2) is symbol('xmlValidatePopElement') {*}
    method ValidatePushCData(xmlCharP $data, int32 $len --> int32) is native(XML2) is symbol('xmlValidatePushCData') {*}
    method ValidatePushElement(xmlDoc $doc, xmlNode $elem, xmlCharP $qname --> int32) is native(XML2) is symbol('xmlValidatePushElement') {*}
    method ValidateRoot(xmlDoc $doc --> int32) is native(XML2) is symbol('xmlValidateRoot') {*}
}

class xmlValidState is repr('CPointer') {
}

our sub xmlSnprintfElementContent(Str $buf, int32 $size, xmlElementContent $content, int32 $englob) is native(XML2) is export {*}
our sub xmlSprintfElementContent(Str $buf, xmlElementContent $content, int32 $englob) is native(XML2) is export {*}
our sub xmlValidGetPotentialChildren(xmlElementContent * $ctree, const xmlChar ** $names, Pointer[int32] $len, int32 $max --> int32) is native(XML2) is export {*}
our sub xmlValidGetValidElements(xmlNode * $prev, xmlNode * $next, const xmlChar ** $names, int32 $max --> int32) is native(XML2) is export {*}
our sub xmlValidateAttributeValue(xmlAttributeType $type, xmlCharP $value --> int32) is native(XML2) is export {*}
our sub xmlValidateNameValue(xmlCharP $value --> int32) is native(XML2) is export {*}
our sub xmlValidateNamesValue(xmlCharP $value --> int32) is native(XML2) is export {*}
our sub xmlValidateNmtokenValue(xmlCharP $value --> int32) is native(XML2) is export {*}
our sub xmlValidateNmtokensValue(xmlCharP $value --> int32) is native(XML2) is export {*}
